"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _changeCase = require("change-case");

var fs = _interopRequireWildcard(require("fs-extra"));

var path = _interopRequireWildcard(require("path"));

var _config = require("./config");

var _getModularRoot = _interopRequireDefault(require("./utils/getModularRoot"));

var _actionPreflightCheck = _interopRequireDefault(require("./utils/actionPreflightCheck"));

var _isModularType = _interopRequireDefault(require("./utils/isModularType"));

var _execSync = _interopRequireDefault(require("./utils/execSync"));

var _getLocation = _interopRequireDefault(require("./utils/getLocation"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

async function build(target, preserveModules) {
  const modularRoot = (0, _getModularRoot.default)();
  const targetPath = await (0, _getLocation.default)(target);

  if ((0, _isModularType.default)(targetPath, 'app')) {
    const buildScript = require.resolve('modular-scripts/react-scripts/scripts/build.js'); // create-react-app doesn't support plain module outputs yet,
    // so --preserve-modules has no effect here


    await fs.remove(path.join(_config.outputDirectory, (0, _changeCase.paramCase)(target))); // TODO: this shouldn't be sync

    (0, _execSync.default)('node', [buildScript], {
      cwd: targetPath,
      log: false,
      // @ts-ignore
      env: {
        MODULAR_ROOT: modularRoot
      }
    });
    await fs.move(path.join(targetPath, 'build'), path.join(_config.outputDirectory, (0, _changeCase.paramCase)(target)));
  } else {
    const {
      buildPackage
    } = await Promise.resolve().then(() => _interopRequireWildcard(require('./buildPackage'))); // ^ we do a dynamic import here to defer the module's initial side effects
    // till when it's actually needed (i.e. now)

    await buildPackage(target, preserveModules);
  }
}

var _default = (0, _actionPreflightCheck.default)(build);

exports.default = _default;